Index: dll/win32/shdocvw/version.rc
===================================================================
--- dll/win32/shdocvw/version.rc	(Revision 31635)
+++ dll/win32/shdocvw/version.rc	(Arbeitskopie)
@@ -13,15 +13,15 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #define WINE_OLESELFREGISTER
 #define WINE_FILEDESCRIPTION_STR "Wine core dll"
 #define WINE_FILENAME_STR "shdocvw.dll"
-#define WINE_FILEVERSION 5,50,0,0
-#define WINE_FILEVERSION_STR "5.50.0.0"
-#define WINE_PRODUCTVERSION 5,50,0,0
-#define WINE_PRODUCTVERSION_STR "5.50"
+#define WINE_FILEVERSION 6,0,2900,2180
+#define WINE_FILEVERSION_STR "6.0.2900.2180"
+#define WINE_PRODUCTVERSION 6,0,2900,2180
+#define WINE_PRODUCTVERSION_STR "6.0.2900.2180"
 
 #include "wine/wine_common_ver.rc"
Index: dll/win32/shdocvw/factory.c
===================================================================
--- dll/win32/shdocvw/factory.c	(Revision 31635)
+++ dll/win32/shdocvw/factory.c	(Arbeitskopie)
@@ -15,13 +15,19 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include <string.h>
-#include "wine/debug.h"
+#include <stdio.h>
+
 #include "shdocvw.h"
+#include "winreg.h"
+#include "advpub.h"
+#include "isguids.h"
 
+#include "wine/debug.h"
+
 WINE_DEFAULT_DEBUG_CHANNEL(shdocvw);
 
 /**********************************************************************
@@ -30,6 +36,8 @@
  * (Based on implementation in ddraw/main.c)
  */
 
+#define FACTORY(x) ((IClassFactory*) &(x)->lpVtbl)
+
 /**********************************************************************
  * WBCF_QueryInterface (IUnknown)
  */
@@ -43,6 +51,7 @@
 
     if(IsEqualGUID(&IID_IUnknown, riid) || IsEqualGUID(&IID_IClassFactory, riid)) {
         *ppobj = iface;
+        IClassFactory_AddRef(iface);
         return S_OK;
     }
 
@@ -78,7 +87,8 @@
 static HRESULT WINAPI WBCF_CreateInstance(LPCLASSFACTORY iface, LPUNKNOWN pOuter,
                                           REFIID riid, LPVOID *ppobj)
 {
-    return WebBrowser_Create(pOuter, riid, ppobj);
+    IClassFactoryImpl *This = (IClassFactoryImpl *) iface;
+    return This->cf(pOuter, riid, ppobj);
 }
 
 /************************************************************************
@@ -105,4 +115,174 @@
     WBCF_LockServer
 };
 
-IClassFactoryImpl SHDOCVW_ClassFactory = {&WBCF_Vtbl};
+/*************************************************************************
+ *              DllGetClassObject (SHDOCVW.@)
+ */
+HRESULT WINAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, void **ppv)
+{
+    static IClassFactoryImpl WB1ClassFactory = {&WBCF_Vtbl, WebBrowserV1_Create};
+    static IClassFactoryImpl WB2ClassFactory = {&WBCF_Vtbl, WebBrowserV2_Create};
+    static IClassFactoryImpl CUHClassFactory = {&WBCF_Vtbl, CUrlHistory_Create};
+
+    TRACE("\n");
+
+    if(IsEqualGUID(&CLSID_WebBrowser, rclsid))
+        return IClassFactory_QueryInterface(FACTORY(&WB2ClassFactory), riid, ppv);
+
+    if(IsEqualGUID(&CLSID_WebBrowser_V1, rclsid))
+        return IClassFactory_QueryInterface(FACTORY(&WB1ClassFactory), riid, ppv);
+
+    if(IsEqualGUID(&CLSID_CUrlHistory, rclsid))
+        return IClassFactory_QueryInterface(FACTORY(&CUHClassFactory), riid, ppv);
+
+    /* As a last resort, figure if the CLSID belongs to a 'Shell Instance Object' */
+    return SHDOCVW_GetShellInstanceObjectClassObject(rclsid, riid, ppv);
+}
+
+HRESULT register_class_object(BOOL do_reg)
+{
+    HRESULT hres;
+
+    static DWORD cookie;
+    static IClassFactoryImpl IEClassFactory = {&WBCF_Vtbl, InternetExplorer_Create};
+
+    if(do_reg) {
+        hres = CoRegisterClassObject(&CLSID_InternetExplorer, (IUnknown*)FACTORY(&IEClassFactory),
+                                     CLSCTX_SERVER, REGCLS_MULTIPLEUSE|REGCLS_SUSPENDED, &cookie);
+        if (FAILED(hres)) {
+            ERR("failed to register object %08x\n", hres);
+            return hres;
+        }
+
+        hres = CoResumeClassObjects();
+        if(SUCCEEDED(hres))
+            return hres;
+
+        ERR("failed to resume object %08x\n", hres);
+    }
+
+    return CoRevokeClassObject(cookie);
+}
+
+static HRESULT reg_install(LPCSTR section, STRTABLEA *strtable)
+{
+    typeof(RegInstallA) *pRegInstall;
+    HMODULE hadvpack;
+    HRESULT hres;
+
+    static const WCHAR advpackW[] = {'a','d','v','p','a','c','k','.','d','l','l',0};
+
+    hadvpack = LoadLibraryW(advpackW);
+    pRegInstall = (typeof(RegInstallA)*)GetProcAddress(hadvpack, "RegInstall");
+
+    hres = pRegInstall(shdocvw_hinstance, section, strtable);
+
+    FreeLibrary(hadvpack);
+    return hres;
+}
+
+/* FIXME: Copy from ddk/isguids.h which is not static */
+static const GUID CLSID_InternetShortcut =
+    {0xFBF23B40, 0xE3F0, 0x101B, {0x84, 0x88, 0x00, 0xAA, 0x00, 0x3E, 0x56, 0xF8}};
+static const GUID CLSID_MicrosoftBrowserArchitecture =
+    {0xa5e46e3a, 0x8849, 0x11d1, {0x9d, 0x8c, 0x00, 0xc0, 0x4f, 0xc9, 0x9d, 0x61}};
+static const GUID CLSID_MruLongList =
+    {0x53bd6b4e, 0x3780, 0x4693, {0xaf, 0xc3, 0x71, 0x61, 0xc2, 0xf3, 0xee, 0x9c}};
+
+#define INF_SET_CLSID(clsid)                  \
+    do                                        \
+    {                                         \
+        static CHAR name[] = "CLSID_" #clsid; \
+                                              \
+        pse[i].pszName = name;                \
+        clsids[i++] = &CLSID_ ## clsid;       \
+    } while (0)
+
+static HRESULT register_server(BOOL doregister)
+{
+    STRTABLEA strtable;
+    STRENTRYA pse[14];
+    static CLSID const *clsids[14];
+    int i = 0;
+    HRESULT hres;
+
+    INF_SET_CLSID(CUrlHistory);
+    INF_SET_CLSID(Internet);
+    INF_SET_CLSID(InternetExplorer);
+    INF_SET_CLSID(InternetShortcut);
+    INF_SET_CLSID(MicrosoftBrowserArchitecture);
+    INF_SET_CLSID(MruLongList);
+    INF_SET_CLSID(SearchAssistantOC);
+    INF_SET_CLSID(ShellNameSpace);
+    INF_SET_CLSID(ShellSearchAssistantOC);
+    INF_SET_CLSID(ShellShellNameSpace);
+    INF_SET_CLSID(ShellUIHelper);
+    INF_SET_CLSID(ShellWindows);
+    INF_SET_CLSID(WebBrowser);
+    INF_SET_CLSID(WebBrowser_V1);
+
+    for(i = 0; i < sizeof(pse)/sizeof(pse[0]); i++) {
+        pse[i].pszValue = HeapAlloc(GetProcessHeap(), 0, 39);
+        sprintf(pse[i].pszValue, "{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
+                clsids[i]->Data1, clsids[i]->Data2, clsids[i]->Data3, clsids[i]->Data4[0],
+                clsids[i]->Data4[1], clsids[i]->Data4[2], clsids[i]->Data4[3], clsids[i]->Data4[4],
+                clsids[i]->Data4[5], clsids[i]->Data4[6], clsids[i]->Data4[7]);
+    }
+
+    strtable.cEntries = sizeof(pse)/sizeof(pse[0]);
+    strtable.pse = pse;
+
+    hres = reg_install(doregister ? "RegisterDll" : "UnregisterDll", &strtable);
+
+    for(i=0; i < sizeof(pse)/sizeof(pse[0]); i++)
+        HeapFree(GetProcessHeap(), 0, pse[i].pszValue);
+
+    return hres;
+}
+
+#undef INF_SET_CLSID
+
+/***********************************************************************
+ *          DllRegisterServer (shdocvw.@)
+ */
+HRESULT WINAPI DllRegisterServer(void)
+{
+    ITypeLib *typelib;
+    HRESULT hres;
+
+    static const WCHAR shdocvwW[] = {'s','h','d','o','c','v','w','.','d','l','l',0};
+
+    hres = register_server(TRUE);
+    if(FAILED(hres))
+        return hres;
+
+    hres = LoadTypeLibEx(shdocvwW, REGKIND_REGISTER, &typelib);
+    if(FAILED(hres)) {
+        ERR("Could not load typelib: %08x\n", hres);
+        return hres;
+    }
+
+    ITypeLib_Release(typelib);
+
+    return hres;
+}
+
+/***********************************************************************
+ *          DllUnregisterServer (shdocvw.@)
+ */
+HRESULT WINAPI DllUnregisterServer(void)
+{
+    HRESULT hres;
+
+    hres = register_server(FALSE);
+    if(FAILED(hres))
+        return hres;
+
+    return UnRegisterTypeLib(&LIBID_SHDocVw, 1, 1, LOCALE_SYSTEM_DEFAULT, SYS_WIN32);
+}
+
+DWORD register_iexplore(BOOL doregister)
+{
+    HRESULT hres = reg_install(doregister ? "RegisterIE" : "UnregisterIE", NULL);
+    return !SUCCEEDED(hres);
+}
Index: dll/win32/shdocvw/view.c
===================================================================
--- dll/win32/shdocvw/view.c	(Revision 31635)
+++ dll/win32/shdocvw/view.c	(Arbeitskopie)
@@ -13,7 +13,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include "wine/debug.h"
Index: dll/win32/shdocvw/shdocvw.rbuild
===================================================================
--- dll/win32/shdocvw/shdocvw.rbuild	(Revision 31635)
+++ dll/win32/shdocvw/shdocvw.rbuild	(Arbeitskopie)
@@ -1,3 +1,5 @@
+<?xml version="1.0"?>
+<!DOCTYPE module SYSTEM "../../../tools/rbuild/project.dtd">
 <module name="shdocvw" type="win32dll" baseaddress="${BASEADDRESS_SHDOCVW}" installbase="system32" installname="shdocvw.dll" allowwarnings="true">
 	<autoregister infsection="OleControlDlls" type="Both" />
 	<importlibrary definition="shdocvw.spec.def" />
@@ -5,8 +7,8 @@
 	<include base="ReactOS">include/reactos/wine</include>
 	<define name="__REACTOS__" />
 	<define name="_WIN32_IE">0x600</define>
-	<define name="_WIN32_WINNT">0x501</define>
-	<define name="WINVER">0x501</define>
+	<define name="_WIN32_WINNT">0x600</define>
+	<define name="WINVER">0x600</define>
 	<define name="_SHDOCVW_" />
 	<library>wine</library>
 	<library>uuid</library>
@@ -17,18 +19,24 @@
 	<library>ole32</library>
 	<library>oleaut32</library>
 	<library>urlmon</library>
+	<library>shell32</library>
+	<library>shlwapi</library>
 	<file>classinfo.c</file>
 	<file>client.c</file>
 	<file>dochost.c</file>
 	<file>events.c</file>
 	<file>factory.c</file>
 	<file>frame.c</file>
+	<file>ie.c</file>
+	<file>iexplore.c</file>
 	<file>misc.c</file>
+	<file>navigate.c</file>
 	<file>oleobject.c</file>
 	<file>persist.c</file>
 	<file>regsvr.c</file>
 	<file>shdocvw_main.c</file>
 	<file>shlinstobj.c</file>
+	<file>urlhist.c</file>
 	<file>view.c</file>
 	<file>webbrowser.c</file>
 	<file>shdocvw.rc</file>
Index: dll/win32/shdocvw/shlinstobj.c
===================================================================
--- dll/win32/shdocvw/shlinstobj.c	(Revision 31635)
+++ dll/win32/shdocvw/shlinstobj.c	(Arbeitskopie)
@@ -15,7 +15,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 /* 'Shell Instance Objects' allow you to add a node to the shell namespace
@@ -170,7 +170,7 @@
     RegistryPropertyBag_IPropertyBag_Write
 };
 
-HRESULT RegistryPropertyBag_Constructor(HKEY hInitPropertyBagKey, REFIID riid, LPVOID *ppvObject) {
+static HRESULT RegistryPropertyBag_Constructor(HKEY hInitPropertyBagKey, REFIID riid, LPVOID *ppvObject) {
     HRESULT hr = E_FAIL;
     RegistryPropertyBag *pRegistryPropertyBag;
 
@@ -314,8 +314,8 @@
     InstanceObjectFactory_IClassFactory_LockServer
 };
 
-HRESULT InstanceObjectFactory_Constructor(REFCLSID rclsid, IPropertyBag *pPropertyBag, REFIID riid,
-    LPVOID *ppvObject)
+static HRESULT InstanceObjectFactory_Constructor(REFCLSID rclsid, IPropertyBag *pPropertyBag,
+                                                 REFIID riid, LPVOID *ppvObject)
 {
     InstanceObjectFactory *pInstanceObjectFactory;
     HRESULT hr = E_FAIL;
@@ -375,7 +375,7 @@
     TRACE("(rclsid=%s, riid=%s, ppvClassObject=%p)\n", debugstr_guid(rclsid), debugstr_guid(riid),
           ppvClassObj);
 
-    /* Figure if there is an 'Instance' subkey for the given CLSID and aquire a handle. */
+    /* Figure if there is an 'Instance' subkey for the given CLSID and acquire a handle. */
     if (!StringFromGUID2(rclsid, wszInstanceKey + 6, CHARS_IN_GUID) ||
         !(wszInstanceKey[5+CHARS_IN_GUID]='\\') || /* Repair the null-termination. */
         ERROR_SUCCESS != RegOpenKeyExW(HKEY_CLASSES_ROOT, wszInstanceKey, 0, KEY_READ, &hInstanceKey))
